﻿using System;
using System.Data;
using System.Data.OleDb;
using System.IO;

namespace JetDatabase
{
    internal class Program
    {
        private static string shapeFileFileName = "../../../App_Data/WorldCapitals.shp";
        private static string sqlStatement = "Select * from [WORLDC~1] ";

        private static void Main(string[] args)
        {
            MockUpDatabaseOperation();

            Console.ReadKey();
        }

        private static void MockUpDatabaseOperation()
        {
            OleDbCommand command = GetOleDbCommand(sqlStatement);
            DataTable dataTable = new DataTable();

            OleDbDataAdapter dataAdapter = new OleDbDataAdapter(command);
            dataAdapter.Fill(dataTable);

            Console.WriteLine(string.Format("Get {0} rows", dataTable.Rows.Count));
        }

        private static OleDbCommand GetOleDbCommand(string sqlStatement)
        {
            OleDbConnection connection;
            if (Environment.Is64BitProcess)
            {
                connection = new OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + Path.GetDirectoryName(shapeFileFileName) + "\\;Extended Properties=dBASE IV;User ID=Admin;Password=");
            }
            else
            {
                connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Path.GetDirectoryName(shapeFileFileName) + "\\;Extended Properties=dBASE IV;User ID=Admin;Password=");
            }

            if (connection.State != ConnectionState.Open)
            {
                connection.Open();
            }

            return new OleDbCommand(sqlStatement, connection);
        }
    }
}